/// <reference types="node" />
import Redis, { Cluster } from "ioredis";
import { Logger } from "winston";
import { Pool } from "generic-pool";
import { RelayerApp } from "../../application";
import { MissedVaaRunStats } from "./helpers";
import { FilterIdentifier, MissedVaaOpts } from "./worker";
export type ProcessVaaFn = (x: Buffer) => Promise<void>;
export declare function checkForMissedVaas(filter: FilterIdentifier, redis: Cluster | Redis, processVaa: ProcessVaaFn, opts: MissedVaaOpts, prefix: string, previousSafeSequence?: bigint | null, logger?: Logger): Promise<MissedVaaRunStats>;
export declare function refreshSeenSequences(redisPool: Pool<Redis | Cluster>, filters: FilterIdentifier[], opts: MissedVaaOpts): Promise<void>;
export declare function registerEventListeners(app: RelayerApp<any>, redisPool: Pool<Redis | Cluster>, opts: MissedVaaOpts, prefix: string): Promise<void>;
